Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QPlainTextEdit

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.core.QObject
                      com.trolltech.qt.gui.QWidget
                          com.trolltech.qt.gui.QFrame
                              com.trolltech.qt.gui.QAbstractScrollArea
                                  com.trolltech.qt.gui.QPlainTextEdit

All Implemented Interfaces:
  QPaintDeviceInterface, QtJambiInterface

    public class QPlainTextEdit

extends QAbstractScrollArea

The `QPlainTextEdit` class provides a widget that is used to edit and display plain text.

- Introduction and Concepts
- Using QPlainTextEdit as a Display Widget

- Read-only Key Bindings

- Using QPlainTextEdit as an Editor

- Syntax Highlighting
- Editing Key Bindings

- Differences to QTextEdit

## Introduction and Concepts

`QPlainTextEdit` is an advanced viewer/editor supporting plain text. It is optimized to handle large documents and to respond quickly to user input.

QPlainText uses very much the same technology and concepts as `QTextEdit`, but is optimized for plain text handling.

`QPlainTextEdit` works on paragraphs and characters. A paragraph is a formatted string which is word-wrapped to fit into the width of the widget. By default when reading plain text, one newline signifies a paragraph. A document consists of zero or more paragraphs. The words in the paragraph are aligned in accordance with the paragraph's alignment. Paragraphs are separated by hard line breaks. Each character within a paragraph has its own attributes, for example, font and color.

The shape of the mouse cursor on a `QPlainTextEdit` is `Qt::IBeamCursor` by default. It can be changed through the `viewport()`'s cursor property.

## Using QPlainTextEdit as a Display Widget

The text is set or replaced using `setPlainText()` which deletes any existing text and replaces it with the text passed in the `setPlainText()` call.

Text itself can be inserted using the `QTextCursor` class or using the convenience functins `insertPlainText()`, `appendPlainText()` or `paste()`.

By default the text edit wraps words at whitespace to fit within the text edit widget. The `setLineWrapMode()` function is used to specify the kind of line wrap you want, `WidgetWidth` or `NoWrap` if you don't want any wrapping. If you use word wrap to the widget's width `WidgetWidth` , you can specify whether to break on whitespace or anywhere with `setWordWrapMode()`.

The `find()` function can be used to find and select a given string within the text.

If you want to limit the total number of paragraphs in a `QPlainTextEdit`, as it is for example useful in a log viewer, then you can use the `maximumBlockCount` property. The combination of `setMaximumBlockCount()` and `appendPlainText()` turns `QPlainTextEdit` into an efficient viewer for log text. The scrolling can be reduced with the `centerOnScroll()` property, making the log viewer even faster. Text can be formatted in a limited way, either using a syntax highlighter (see below), or by appending html-formatted text with `appendHtml()`. While `QPlainTextEdit` does not support complex rich text rendering with tables and floats, it does support limited paragraph-based formatting that you may need in a log viewer.

### Read-only Key Bindings

When `QPlainTextEdit` is used read-only the key bindings are limited to navigation, and text may only be selected with the mouse:

Keypresses | Action
--- | ---
`Qt::UpArrow` | Moves one line up.
`Qt::DownArrow` | Moves one line down.
`Qt::LeftArrow` | Moves one character to the left.
`Qt::RightArrow` | Moves one character to the right.
PageUp | Moves one (viewport) page up.
PageDown | Moves one (viewport) page down.
Home | Moves to the beginning of the text.
End | Moves to the end of the text.
Alt+Wheel | Scrolls the page horizontally (the Wheel is the mouse wheel).
Ctrl+Wheel | Zooms the text.
Ctrl+A | Selects all text.

## Using QPlainTextEdit as an Editor

All the information about using `QPlainTextEdit` as a display widget also applies here.

Selection of text is handled by the `QTextCursor` class, which provides functionality for creating selections, retrieving the text contents or deleting selections. You can retrieve the object that corresponds with the user-visible cursor using the `textCursor()` method. If you want to set a selection in `QPlainTextEdit` just create one on a `QTextCursor` object and then make that cursor the visible cursor using setCursor(). The selection can be copied to the clipboard with `copy()`, or cut to the clipboard with `cut()`. The entire text can be selected using `selectAll()`.

`QPlainTextEdit` holds a `QTextDocument` object which can be retrieved using the `document()` method. You can also set your own document object using `setDocument()`. `QTextDocument` emits a `textChanged()` signal if the text changes and it also provides a isModified() function which will return true if the text has been modified since it was either loaded or since the last call to setModified with false as argument. In addition it provides methods for undo and redo.

### Syntax Highlighting

Just like `QTextEdit`, `QPlainTextEdit` works together with `QSyntaxHighlighter`.

### Editing Key Bindings

The list of key bindings which are implemented for editing:

Keypresses | Action
--- | ---
Backspace | Deletes the character to the left of the cursor.
Delete | Deletes the character to the right of the cursor.
Ctrl+C | Copy the selected text to the clipboard.
Ctrl+Insert | Copy the selected text to the clipboard.
Ctrl+K | Deletes to the end of the line.
Ctrl+V | Pastes the clipboard text into text edit.
Shift+Insert | Pastes the clipboard text into text edit.
Ctrl+X | Deletes the selected text and copies it to the clipboard.
Shift+Delete | Deletes the selected text and copies it to the clipboard.
Ctrl+Z | Undoes the last operation.
Ctrl+Y | Redoes the last operation.
LeftArrow | Moves the cursor one character to the left.
Ctrl+LeftArrow | Moves the cursor one word to the left.
RightArrow | Moves the cursor one character to the right.
Ctrl+RightArrow | Moves the cursor one word to the right.
UpArrow | Moves the cursor one line up.
Ctrl+UpArrow | Moves the cursor one word up.
DownArrow | Moves the cursor one line down.
Ctrl+Down Arrow | Moves the cursor one word down.
PageUp | Moves the cursor one page up.
PageDown | Moves the cursor one page down.
Home | Moves the cursor to the beginning of the line.
Ctrl+Home | Moves the cursor to the beginning of the text.
End | Moves the cursor to the end of the line.
Ctrl+End | Moves the cursor to the end of the text.
Alt+Wheel | Scrolls the page horizontally (the Wheel is the mouse wheel).
Ctrl+Wheel | Zooms the text.

To select (mark) text hold down the Shift key whilst pressing one of the movement keystrokes, for example, Shift+Right Arrow will select the character to the right, and Shift+Ctrl+Right Arrow will select the word to the right, etc.

## Differences to QTextEdit

`QPlainTextEdit` is a thin class, implemented by using most of the technology that is behind `QTextEdit` and `QTextDocument`. Its performance benefits over `QTextEdit` stem mostly from using a different and simplified text layout called `QPlainTextDocumentLayout` on the text document (see `QTextDocument::setDocumentLayout()`). The plain text document layout does not support tables nor embedded frames, and replaces a pixel-exact height calculation with a line-by-line respectively paragraph-by-paragraph scrolling approach. This makes it possible to handle significantly larger documents, and still resize the editor with line wrap enabled in real time. It also makes for a fast log viewer (see `setMaximumBlockCount()`).

See also:
  `QTextDocument`, `QTextCursor`, Application Example, Syntax Highlighter Example, and Rich Text Processing.

Nested Class Summary
`static class` | `QPlainTextEdit.LineWrapMode`

Nested classes/interfaces inherited from class com.trolltech.qt.gui.QFrame
`QFrame.Shadow, QFrame.Shape, QFrame.StyleMask`

Nested classes/interfaces inherited from class com.trolltech.qt.gui.QWidget
`QWidget.RenderFlag, QWidget.RenderFlags`

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary
`QSignalEmitter.Signal1` | `blockCountChanged` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal1` | `copyAvailable` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal0` | `cursorPositionChanged` This signal is emitted whenever the position of the cursor changed.
`QSignalEmitter.Signal1` | `modificationChanged` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal1` | `redoAvailable` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal0` | `selectionChanged` This signal is emitted whenever the selection changes.
`QSignalEmitter.Signal0` | `textChanged` This signal is emitted whenever the document's content changes; for example, when text is inserted or deleted, or when formatting is applied.
`QSignalEmitter.Signal1` | `undoAvailable` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal2` | `updateRequest` This signal takes 2 generic argument(s).

Fields inherited from class com.trolltech.qt.gui.QWidget
`customContextMenuRequested`

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QPlainTextEdit()` Constructs an empty `QPlainTextEdit` with parent `parent`.
`QPlainTextEdit(QWidget parent)` Constructs an empty `QPlainTextEdit` with parent `parent`.
`QPlainTextEdit(java.lang.String text)` Constructs a `QPlainTextEdit` with parent `parent`.
`QPlainTextEdit(java.lang.String text, QWidget parent)` Constructs a `QPlainTextEdit` with parent `parent`.

Method Summary
`void` | `appendHtml(java.lang.String html)` Appends a new paragraph with `html` to the end of the text edit.
`void` | `appendPlainText(java.lang.String text)` Appends a new paragraph with `text` to the end of the text edit.
`boolean` | `backgroundVisible()` This property holds whether the palette background is visible outside the document area.
`protected QRectF` | `blockBoundingGeometry(QTextBlock block)` Returns the bounding rectangle of the text `block` in content coordinates.
`protected QRectF` | `blockBoundingRect(QTextBlock block)` Returns the bounding rectangle of the text `block` in the block's own coordinates.
`int` | `blockCount()` This property holds the number of text blocks in the document.
`protected boolean` | `canInsertFromMimeData(QMimeData source)` This function returns true if the contents of the MIME data object, specified by `source`, can be decoded and inserted into the document.
`boolean` | `canPaste()` Returns whether text can be pasted from the clipboard into the textedit.
`void` | `centerCursor()` Scrolls the document in order to center the cursor vertically.
`boolean` | `centerOnScroll()` This property holds whether the cursor should be centered on screen.
`void` | `clear()` Deletes all the text in the text edit.
`protected QPointF` | `contentOffset()` Returns the content's origin in viewport coordinates.
`void` | `copy()` Copies any selected text to the clipboard.
`protected QMimeData` | `createMimeDataFromSelection()` This function returns a new MIME data object to represent the contents of the text edit's current selection.
`QMenu` | `createStandardContextMenu()` This function creates the standard context menu which is shown when the user clicks on the line edit with the right mouse button.
`QTextCharFormat` | `currentCharFormat()` Returns the char format that is used when inserting new text.
`QTextCursor` | `cursorForPosition(QPoint pos)` returns a `QTextCursor` at position `pos` (in viewport coordinates).
`QRect` | `cursorRect()` returns a rectangle (in viewport coordinates) that includes the cursor of the text edit.
`QRect` | `cursorRect(QTextCursor cursor)` returns a rectangle (in viewport coordinates) that includes the `cursor`.
`int` | `cursorWidth()` This property specifies the width of the cursor in pixels.
`void` | `cut()` Copies the selected text to the clipboard and deletes it from the text edit.
`QTextDocument` | `document()` Returns a pointer to the underlying document.
`java.lang.String` | `documentTitle()` This property holds the title of the document parsed from the text.
`void` | `ensureCursorVisible()` Ensures that the cursor is visible by scrolling the text edit if necessary.
`java.util.List` | `extraSelections()` Returns previously set extra selections.
`boolean` | `find(java.lang.String exp)` Finds the next occurrence of the string, `exp`, using the given `options`.
`boolean` | `find(java.lang.String exp, QTextDocument.FindFlag[] options)` Finds the next occurrence of the string, `exp`, using the given `options`.
`boolean` | `find(java.lang.String exp, QTextDocument.FindFlags options)` Finds the next occurrence of the string, `exp`, using the given `options`.
`protected QTextBlock` | `firstVisibleBlock()` Returns the first visible block.
`protected QAbstractTextDocumentLayout_PaintContext` | `getPaintContext()` Returns the paint context for the `viewport()`, useful only when reimplementing `paintEvent()`.
`protected void` | `insertFromMimeData(QMimeData source)` This function inserts the contents of the MIME data object, specified by `source`, into the text edit at the current cursor position.
`void` | `insertPlainText(java.lang.String text)` Convenience slot that inserts `text` at the current cursor position.
`boolean` | `isReadOnly()` This property holds whether the text edit is read-only.
`boolean` | `isUndoRedoEnabled()` This property holds whether undo and redo are enabled.
`QPlainTextEdit.LineWrapMode` | `lineWrapMode()` This property holds the line wrap mode.
`java.lang.Object` | `loadResource(int type, QUrl name)` Loads the resource specified by the given `type` and `name`.
`int` | `maximumBlockCount()` This property holds the limit for blocks in the document.
`void` | `mergeCurrentCharFormat(QTextCharFormat modifier)` Merges the properties specified in `modifier` into the current character format by calling QTextCursor.:mergeCharFormat on the editor's cursor.
`void` | `moveCursor(QTextCursor.MoveOperation operation)` Moves the cursor by performing the given `operation`.
`void` | `moveCursor(QTextCursor.MoveOperation operation, QTextCursor.MoveMode mode)` Moves the cursor by performing the given `operation`.
`boolean` | `overwriteMode()` This property holds whether text entered by the user will overwrite existing text.
`void` | `paste()` Pastes the text from the clipboard into the text edit at the current cursor position.
`void` | `print(QPrinter printer)` Convenience function to print the text edit's document to the given `printer`.
`void` | `redo()` Redoes the last operation.
`void` | `selectAll()` Selects all text.
`void` | `setBackgroundVisible(boolean visible)` This property holds whether the palette background is visible outside the document area.
`void` | `setCenterOnScroll(boolean enabled)` This property holds whether the cursor should be centered on screen.
`void` | `setCurrentCharFormat(QTextCharFormat format)` Sets the char format that is be used when inserting new text to `format` by calling `QTextCursor::setCharFormat()` on the editor's cursor.
`void` | `setCursorWidth(int width)` This property specifies the width of the cursor in pixels.
`void` | `setDocument(QTextDocument document)` Makes `document` the new document of the text editor.
`void` | `setDocumentTitle(java.lang.String title)` This property holds the title of the document parsed from the text.
`void` | `setExtraSelections(java.util.List selections)` This function allows temporarily marking certain regions in the document with a given color, specified as `selections`.
`void` | `setLineWrapMode(QPlainTextEdit.LineWrapMode mode)` This property holds the line wrap mode.
`void` | `setMaximumBlockCount(int maximum)` This property holds the limit for blocks in the document.
`void` | `setOverwriteMode(boolean overwrite)` This property holds whether text entered by the user will overwrite existing text.
`void` | `setPlainText(java.lang.String text)` This property gets and sets the plain text editor's contents.
`void` | `setReadOnly(boolean ro)` This property holds whether the text edit is read-only.
`void` | `setTabChangesFocus(boolean b)` This property holds whether Tab changes focus or is accepted as input.
`void` | `setTabStopWidth(int width)` This property holds the tab stop width in pixels.
`void` | `setTextCursor(QTextCursor cursor)` Sets the visible `cursor`.
`void` | `setTextInteractionFlags(Qt.TextInteractionFlag[] flags)` Specifies how the label should interact with user input if it displays text.
`void` | `setTextInteractionFlags(Qt.TextInteractionFlags flags)` Specifies how the label should interact with user input if it displays text.
`void` | `setUndoRedoEnabled(boolean enable)` This property holds whether undo and redo are enabled.
`void` | `setWordWrapMode(QTextOption.WrapMode policy)` This property holds the mode `QPlainTextEdit` will use when wrapping text by words.
`boolean` | `tabChangesFocus()` This property holds whether Tab changes focus or is accepted as input.
`int` | `tabStopWidth()` This property holds the tab stop width in pixels.
`QTextCursor` | `textCursor()` Returns a copy of the `QTextCursor` that represents the currently visible cursor.
`Qt.TextInteractionFlags` | `textInteractionFlags()` Specifies how the label should interact with user input if it displays text.
`java.lang.String` | `toPlainText()` This property gets and sets the plain text editor's contents.
`void` | `undo()` Undoes the last operation.
`QTextOption.WrapMode` | `wordWrapMode()` This property holds the mode `QPlainTextEdit` will use when wrapping text by words.

Methods inherited from class com.trolltech.qt.gui.QAbstractScrollArea
`addScrollBarWidget, addScrollBarWidget, cornerWidget, horizontalScrollBar, horizontalScrollBarPolicy, maximumViewportSize, scrollBarWidgets, scrollBarWidgets, scrollContentsBy, setCornerWidget, setHorizontalScrollBar, setHorizontalScrollBarPolicy, setupViewport, setVerticalScrollBar, setVerticalScrollBarPolicy, setViewport, setViewportMargins, verticalScrollBar, verticalScrollBarPolicy, viewport, viewportEvent`

Methods inherited from class com.trolltech.qt.gui.QFrame
`frameRect, frameShadow, frameShape, frameStyle, frameWidth, lineWidth, midLineWidth, setFrameRect, setFrameShadow, setFrameShape, setFrameStyle, setLineWidth, setMidLineWidth`

Methods inherited from class com.trolltech.qt.gui.QWidget
`acceptDrops, accessibleDescription, accessibleName, actionEvent, actions, activateWindow, addAction, addActions, adjustSize, autoFillBackground, backgroundRole, baseSize, changeEvent, childAt, childAt, childrenRect, childrenRegion, clearFocus, clearMask, close, closeEvent, contentsRect, contextMenuEvent, contextMenuPolicy, cursor, depth, destroy, destroy, destroy, dragEnterEvent, dragLeaveEvent, dragMoveEvent, dropEvent, effectiveWinId, ensurePolished, enterEvent, focusInEvent, focusNextChild, focusNextPrevChild, focusOutEvent, focusPolicy, focusPreviousChild, focusProxy, focusWidget, font, fontInfo, fontMetrics, foregroundRole, frameGeometry, frameSize, geometry, getContentsMargins, grabKeyboard, grabMouse, grabMouse, grabShortcut, grabShortcut, hasFocus, hasMouseTracking, height, heightForWidth, heightMM, hide, hideEvent, inputContext, inputMethodEvent, inputMethodQuery, insertAction, insertActions, isActiveWindow, isAncestorOf, isEnabled, isEnabledTo, isFullScreen, isHidden, isMaximized, isMinimized, isModal, isVisible, isVisibleTo, isWindow, isWindowModified, keyboardGrabber, keyPressEvent, keyReleaseEvent, languageChange, layout, layoutDirection, leaveEvent, locale, logicalDpiX, logicalDpiY, lower, mapFrom, mapFromGlobal, mapFromParent, mapTo, mapToGlobal, mapToParent, mask, maximumHeight, maximumSize, maximumWidth, metric, minimumHeight, minimumSize, minimumSizeHint, minimumWidth, mouseDoubleClickEvent, mouseGrabber, mouseMoveEvent, mousePressEvent, mouseReleaseEvent, move, move, moveEvent, nativeParentWidget, nextInFocusChain, normalGeometry, numColors, overrideWindowFlags, overrideWindowFlags, paintEngine, paintEvent, paintingActive, palette, parentWidget, physicalDpiX, physicalDpiY, pos, raise, rect, releaseKeyboard, releaseMouse, releaseShortcut, removeAction, render, render, render, render, render, render, render, render, render, repaint, repaint, repaint, repaint, resetInputContext, resize, resize, resizeEvent, restoreGeometry, saveGeometry, scroll, scroll, setAcceptDrops, setAccessibleDescription, setAccessibleName, setAttribute, setAttribute, setAutoFillBackground, setBackgroundRole, setBaseSize, setBaseSize, setContentsMargins, setContentsMargins, setContextMenuPolicy, setCursor, setDisabled, setEnabled, setFixedHeight, setFixedSize, setFixedSize, setFixedWidth, setFocus, setFocus, setFocusPolicy, setFocusProxy, setFont, setForegroundRole, setGeometry, setGeometry, setHidden, setInputContext, setLayout, setLayoutDirection, setLocale, setMask, setMask, setMaximumHeight, setMaximumSize, setMaximumSize, setMaximumWidth, setMinimumHeight, setMinimumSize, setMinimumSize, setMinimumWidth, setMouseTracking, setPalette, setParent, setParent, setParent, setShortcutAutoRepeat, setShortcutAutoRepeat, setShortcutEnabled, setShortcutEnabled, setSizeIncrement, setSizeIncrement, setSizePolicy, setSizePolicy, setStatusTip, setStyle, setStyleSheet, setTabOrder, setToolTip, setUpdatesEnabled, setVisible, setWhatsThis, setWindowFilePath, setWindowFlags, setWindowFlags, setWindowIcon, setWindowIconText, setWindowModality, setWindowModified, setWindowOpacity, setWindowRole, setWindowState, setWindowState, setWindowTitle, show, showEvent, showFullScreen, showMaximized, showMinimized, showNormal, size, sizeHint, sizeIncrement, sizePolicy, stackUnder, statusTip, style, styleSheet, tabletEvent, testAttribute, toolTip, underMouse, unsetCursor, unsetLayoutDirection, unsetLocale, update, update, update, update, updateGeometry, updateMicroFocus, updatesEnabled, visibleRegion, whatsThis, wheelEvent, width, widthMM, window, windowFilePath, windowFlags, windowIcon, windowIconText, windowModality, windowOpacity, windowRole, windowState, windowTitle, windowType, winId, x, y`

Methods inherited from class com.trolltech.qt.core.QObject
`childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, event, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, indexOfProperty, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, properties, property, removeEventFilter, setObjectName, setParent, setProperty, startTimer, timerEvent, toString, userProperty`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Field Detail

### blockCountChanged

    public final QSignalEmitter.Signal1 blockCountChanged

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <java.lang.Integer(named: newBlockCount)>:

  This signal is emitted whenever the block count changes. The new block count is passed in `newBlockCount`.

### copyAvailable

    public final QSignalEmitter.Signal1 copyAvailable

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <java.lang.Boolean(named: yes)>:

  This signal is emitted when text is selected or de-selected in the text edit.

  When text is selected this signal will be emitted with `yes` set to true. If no text has been selected or if the selected text is de-selected this signal is emitted with `yes` set to false.

  If `yes` is true then `copy()` can be used to copy the selection to the clipboard. If `yes` is false then `copy()` does nothing.

See also:
  `selectionChanged()` .

### cursorPositionChanged

    public final QSignalEmitter.Signal0 cursorPositionChanged

  This signal is emitted whenever the position of the cursor changed.

### modificationChanged

    public final QSignalEmitter.Signal1 modificationChanged

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <java.lang.Boolean(named: changed)>:

  This signal is emitted whenever the content of the document changes in a way that affects the modification state. If `changed` is true, the document has been modified; otherwise it is false.

  For example, calling setModified(false) on a document and then inserting text causes the signal to get emitted. If you undo that operation, causing the document to return to its original unmodified state, the signal will get emitted again.

### redoAvailable

    public final QSignalEmitter.Signal1 redoAvailable

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <java.lang.Boolean(named: available)>:

  This signal is emitted whenever redo operations become available (`available` is true) or unavailable (`available` is false).

### selectionChanged

    public final QSignalEmitter.Signal0 selectionChanged

  This signal is emitted whenever the selection changes.

See also:
  `copyAvailable()` .

### textChanged

    public final QSignalEmitter.Signal0 textChanged

  This signal is emitted whenever the document's content changes; for example, when text is inserted or deleted, or when formatting is applied.

### undoAvailable

    public final QSignalEmitter.Signal1 undoAvailable

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <java.lang.Boolean(named: available)>:

  This signal is emitted whenever undo operations become available (`available` is true) or unavailable (`available` is false).

### updateRequest

    public final QSignalEmitter.Signal2 updateRequest

  This signal takes 2 generic argument(s). We list their type and the name they go by in the description of this signal. <com.trolltech.qt.core.QRect(named: rect), java.lang.Integer(named: dy)>:

  This signal is emitted when the text document needs an update of the specified `rect`. If the text is scrolled, `rect` will cover the entire viewport area. If the text is scrolled vertically, `dy` carries the amount of pixels the viewport was scrolled.

  The purpose of the signal is to support extra widgets in plain text edit subclasses that e.g. show line numbers, breakpoints, or other extra information.

Constructor Detail

### QPlainTextEdit

    public QPlainTextEdit()

  Constructs an empty `QPlainTextEdit` with parent `parent`.

### QPlainTextEdit

    public QPlainTextEdit(QWidget parent)

  Constructs an empty `QPlainTextEdit` with parent `parent`.

### QPlainTextEdit

    public QPlainTextEdit(java.lang.String text)

  Constructs a `QPlainTextEdit` with parent `parent`. The text edit will display the plain text `text`.

### QPlainTextEdit

    public QPlainTextEdit(java.lang.String text,
                          QWidget parent)

  Constructs a `QPlainTextEdit` with parent `parent`. The text edit will display the plain text `text`.

Method Detail

### appendHtml

    public final void appendHtml(java.lang.String html)

  Appends a new paragraph with `html` to the end of the text edit.

  `appendPlainText()`

### appendPlainText

    public final void appendPlainText(java.lang.String text)

  Appends a new paragraph with `text` to the end of the text edit.

See also:
  `appendHtml()`.

### backgroundVisible

    public final boolean backgroundVisible()

  This property holds whether the palette background is visible outside the document area. If set to true, the plain text edit paints the palette background on the viewport area not covered by the text document. Otherwise, if set to false, it won't. The feature makes it possible for the user to visually distinguish between the area of the document, painted with the base color of the palette, and the empty area not covered by any document.

  The default is false.

### blockBoundingGeometry

    protected final QRectF blockBoundingGeometry(QTextBlock block)

  Returns the bounding rectangle of the text `block` in content coordinates. Translate the rectangle with the `contentOffset()` to get visual coordinates on the viewport.

See also:
  `firstVisibleBlock()`, and `blockBoundingRect()`.

### blockBoundingRect

    protected final QRectF blockBoundingRect(QTextBlock block)

  Returns the bounding rectangle of the text `block` in the block's own coordinates.

See also:
  `blockBoundingGeometry()`.

### blockCount

    public final int blockCount()

  This property holds the number of text blocks in the document. By default, in an empty document, this property contains a value of 1.

### canPaste

    public final boolean canPaste()

  Returns whether text can be pasted from the clipboard into the textedit.

### centerCursor

    public final void centerCursor()

  Scrolls the document in order to center the cursor vertically.

See also:
  `ensureCursorVisible()`, and `centerOnScroll`.

### centerOnScroll

    public final boolean centerOnScroll()

  This property holds whether the cursor should be centered on screen. If set to true, the plain text edit scrolls the document vertically to make the cursor visible at the center of the viewport. This also allows the text edit to scroll below the end of the document. Otherwise, if set to false, the plain text edit scrolls the smallest amount possible to ensure the cursor is visible. The same algorithm is applied to any new line appended through `appendPlainText()`.

  The default is false.

See also:
  `centerCursor()`, and `ensureCursorVisible()`.

### clear

    public final void clear()

  Deletes all the text in the text edit.

  Note that the undo/redo history is cleared by this function.

See also:
  `cut()`, and `setPlainText()`.

### contentOffset

    protected final QPointF contentOffset()

  Returns the content's origin in viewport coordinates.

  The origin of the content of a plain text edit is always the top left corner of the first visible text block. The content offset is different from (0,0) when the text has been scrolled horizontally, or when the first visible block has been scrolled partially off the screen, i.e. the visible text does not start with the first line of the first visible block, or when the first visible block is the very first block and the editor displays a margin.

See also:
  `firstVisibleBlock()`, `horizontalScrollBar()`, and `verticalScrollBar()`.

### copy

    public final void copy()

  Copies any selected text to the clipboard.

See also:
  `copyAvailable()` .

### createStandardContextMenu

    public final QMenu createStandardContextMenu()

  This function creates the standard context menu which is shown when the user clicks on the line edit with the right mouse button. It is called from the default `contextMenuEvent()` handler. The popup menu's ownership is transferred to the caller.

### currentCharFormat

    public final QTextCharFormat currentCharFormat()

  Returns the char format that is used when inserting new text.

See also:
  `setCurrentCharFormat()`.

### cursorForPosition

    public final QTextCursor cursorForPosition(QPoint pos)

  returns a `QTextCursor` at position `pos` (in viewport coordinates).

### cursorRect

    public final QRect cursorRect()

  returns a rectangle (in viewport coordinates) that includes the cursor of the text edit.

### cursorRect

    public final QRect cursorRect(QTextCursor cursor)

  returns a rectangle (in viewport coordinates) that includes the `cursor`.

### cursorWidth

    public final int cursorWidth()

  This property specifies the width of the cursor in pixels. The default value is 1.

### cut

    public final void cut()

  Copies the selected text to the clipboard and deletes it from the text edit.

  If there is no selected text nothing happens.

See also:
  `copy()`, and `paste()`.

### document

    public final QTextDocument document()

  Returns a pointer to the underlying document.

See also:
  `setDocument()`.

### documentTitle

    public final java.lang.String documentTitle()

  This property holds the title of the document parsed from the text. By default, this property contains an empty string.

### ensureCursorVisible

    public final void ensureCursorVisible()

  Ensures that the cursor is visible by scrolling the text edit if necessary.

See also:
  `centerCursor()`, and `centerOnScroll`.

### extraSelections

    public final java.util.List extraSelections()

  Returns previously set extra selections.

See also:
  `setExtraSelections()`.

### find

    public final boolean find(java.lang.String exp,
                              QTextDocument.FindFlag[] options)

  Finds the next occurrence of the string, `exp`, using the given `options`. Returns true if `exp` was found and changes the cursor to select the match; otherwise returns false.

### find

    public final boolean find(java.lang.String exp)

  Finds the next occurrence of the string, `exp`, using the given `options`. Returns true if `exp` was found and changes the cursor to select the match; otherwise returns false.

### find

    public final boolean find(java.lang.String exp,
                              QTextDocument.FindFlags options)

  Finds the next occurrence of the string, `exp`, using the given `options`. Returns true if `exp` was found and changes the cursor to select the match; otherwise returns false.

### firstVisibleBlock

    protected final QTextBlock firstVisibleBlock()

  Returns the first visible block.

See also:
  `blockBoundingRect()`.

### getPaintContext

    protected final QAbstractTextDocumentLayout_PaintContext getPaintContext()

  Returns the paint context for the `viewport()`, useful only when reimplementing `paintEvent()`.

### insertPlainText

    public final void insertPlainText(java.lang.String text)

  Convenience slot that inserts `text` at the current cursor position.

  It is equivalent to

          edit.textCursor().insertText(text);

### isReadOnly

    public final boolean isReadOnly()

  This property holds whether the text edit is read-only. In a read-only text edit the user can only navigate through the text and select text; modifying the text is not possible.

  This property's default is false.

### isUndoRedoEnabled

    public final boolean isUndoRedoEnabled()

  This property holds whether undo and redo are enabled. Users are only able to undo or redo actions if this property is true, and if there is an action that can be undone (or redone).

  By default, this property is true.

### lineWrapMode

    public final QPlainTextEdit.LineWrapMode lineWrapMode()

  This property holds the line wrap mode. The default mode is `WidgetWidth` which causes words to be wrapped at the right edge of the text edit. Wrapping occurs at whitespace, keeping whole words intact. If you want wrapping to occur within words use setWrapPolicy(). If you set a wrap mode of FixedPixelWidth or FixedColumnWidth you should also call setWrapColumnOrWidth() with the width you want.

### maximumBlockCount

    public final int maximumBlockCount()

  This property holds the limit for blocks in the document. Specifies the maximum number of blocks the document may have. If there are more blocks in the document that specified with this property blocks are removed from the beginning of the document.

  A negative or zero value specifies that the document may contain an unlimited amount of blocks.

  The default value is 0.

  Note that setting this property will apply the limit immediately to the document contents. Setting this property also disables the undo redo history.

### mergeCurrentCharFormat

    public final void mergeCurrentCharFormat(QTextCharFormat modifier)

  Merges the properties specified in `modifier` into the current character format by calling QTextCursor.:mergeCharFormat on the editor's cursor. If the editor has a selection then the properties of `modifier` are directly applied to the selection.

See also:
  `QTextCursor::mergeCharFormat()`.

### moveCursor

    public final void moveCursor(QTextCursor.MoveOperation operation)

  Moves the cursor by performing the given `operation`.

  If `mode` is `QTextCursor::KeepAnchor` , the cursor selects the text it moves over. This is the same effect that the user achieves when they hold down the Shift key and move the cursor with the cursor keys.

See also:
  `QTextCursor::movePosition()`.

### moveCursor

    public final void moveCursor(QTextCursor.MoveOperation operation,
                                 QTextCursor.MoveMode mode)

  Moves the cursor by performing the given `operation`.

  If `mode` is `QTextCursor::KeepAnchor` , the cursor selects the text it moves over. This is the same effect that the user achieves when they hold down the Shift key and move the cursor with the cursor keys.

See also:
  `QTextCursor::movePosition()`.

### overwriteMode

    public final boolean overwriteMode()

  This property holds whether text entered by the user will overwrite existing text. As with many text editors, the plain text editor widget can be configured to insert or overwrite existing text with new text entered by the user.

  If this property is true, existing text is overwritten, character-for-character by new text; otherwise, text is inserted at the cursor position, displacing existing text.

  By default, this property is false (new text does not overwrite existing text).

### paste

    public final void paste()

  Pastes the text from the clipboard into the text edit at the current cursor position.

  If there is no text in the clipboard nothing happens.

  To change the behavior of this function, i.e. to modify what `QPlainTextEdit` can paste and how it is being pasted, reimplement the virtual `canInsertFromMimeData()` and `insertFromMimeData()` functions.

See also:
  `cut()`, and `copy()`.

### print

    public final void print(QPrinter printer)

  Convenience function to print the text edit's document to the given `printer`. This is equivalent to calling the print method on the document directly except that this function also supports `QPrinter::Selection` as print range.

See also:
  `QTextDocument::print()`.

### redo

    public final void redo()

  Redoes the last operation.

  If there is no operation to redo, i.e. there is no redo step in the undo/redo history, nothing happens.

See also:
  `undo()`.

### selectAll

    public final void selectAll()

  Selects all text.

See also:
  `copy()`, `cut()`, and `textCursor()`.

### setBackgroundVisible

    public final void setBackgroundVisible(boolean visible)

  This property holds whether the palette background is visible outside the document area. If set to true, the plain text edit paints the palette background on the viewport area not covered by the text document. Otherwise, if set to false, it won't. The feature makes it possible for the user to visually distinguish between the area of the document, painted with the base color of the palette, and the empty area not covered by any document.

  The default is false.

### setCenterOnScroll

    public final void setCenterOnScroll(boolean enabled)

  This property holds whether the cursor should be centered on screen. If set to true, the plain text edit scrolls the document vertically to make the cursor visible at the center of the viewport. This also allows the text edit to scroll below the end of the document. Otherwise, if set to false, the plain text edit scrolls the smallest amount possible to ensure the cursor is visible. The same algorithm is applied to any new line appended through `appendPlainText()`.

  The default is false.

See also:
  `centerCursor()`, and `ensureCursorVisible()`.

### setCurrentCharFormat

    public final void setCurrentCharFormat(QTextCharFormat format)

  Sets the char format that is be used when inserting new text to `format` by calling `QTextCursor::setCharFormat()` on the editor's cursor. If the editor has a selection then the char format is directly applied to the selection.

See also:
  `currentCharFormat()`.

### setCursorWidth

    public final void setCursorWidth(int width)

  This property specifies the width of the cursor in pixels. The default value is 1.

### setDocument

    public final void setDocument(QTextDocument document)

  Makes `document` the new document of the text editor.

  The parent `QObject` of the provided document remains the owner of the object. If the current document is a child of the text editor, then it is deleted.

  The document must have a document layout that inherits `QPlainTextDocumentLayout` (see `QTextDocument::setDocumentLayout()`).

See also:
  `document()`.

### setDocumentTitle

    public final void setDocumentTitle(java.lang.String title)

  This property holds the title of the document parsed from the text. By default, this property contains an empty string.

### setExtraSelections

    public final void setExtraSelections(java.util.List selections)

  This function allows temporarily marking certain regions in the document with a given color, specified as `selections`. This can be useful for example in a programming editor to mark a whole line of text with a given background color to indicate the existence of a breakpoint.

See also:
  QTextEdit::ExtraSelection, and `extraSelections()`.

### setLineWrapMode

    public final void setLineWrapMode(QPlainTextEdit.LineWrapMode mode)

  This property holds the line wrap mode. The default mode is `WidgetWidth` which causes words to be wrapped at the right edge of the text edit. Wrapping occurs at whitespace, keeping whole words intact. If you want wrapping to occur within words use setWrapPolicy(). If you set a wrap mode of FixedPixelWidth or FixedColumnWidth you should also call setWrapColumnOrWidth() with the width you want.

### setMaximumBlockCount

    public final void setMaximumBlockCount(int maximum)

  This property holds the limit for blocks in the document. Specifies the maximum number of blocks the document may have. If there are more blocks in the document that specified with this property blocks are removed from the beginning of the document.

  A negative or zero value specifies that the document may contain an unlimited amount of blocks.

  The default value is 0.

  Note that setting this property will apply the limit immediately to the document contents. Setting this property also disables the undo redo history.

### setOverwriteMode

    public final void setOverwriteMode(boolean overwrite)

  This property holds whether text entered by the user will overwrite existing text. As with many text editors, the plain text editor widget can be configured to insert or overwrite existing text with new text entered by the user.

  If this property is true, existing text is overwritten, character-for-character by new text; otherwise, text is inserted at the cursor position, displacing existing text.

  By default, this property is false (new text does not overwrite existing text).

### setPlainText

    public final void setPlainText(java.lang.String text)

  This property gets and sets the plain text editor's contents. The previous contents are removed and undo/redo history is reset when this property is set.

  By default, for an editor with no contents, this property contains an empty string.

### setReadOnly

    public final void setReadOnly(boolean ro)

  This property holds whether the text edit is read-only. In a read-only text edit the user can only navigate through the text and select text; modifying the text is not possible.

  This property's default is false.

### setTabChangesFocus

    public final void setTabChangesFocus(boolean b)

  This property holds whether Tab changes focus or is accepted as input. In some occasions text edits should not allow the user to input tabulators or change indentation using the Tab key, as this breaks the focus chain. The default is false.

### setTabStopWidth

    public final void setTabStopWidth(int width)

  This property holds the tab stop width in pixels. By default, this property contains a value of 80.

### setTextCursor

    public final void setTextCursor(QTextCursor cursor)

  Sets the visible `cursor`.

See also:
  `textCursor()`.

### setTextInteractionFlags

    public final void setTextInteractionFlags(Qt.TextInteractionFlag[] flags)

  Specifies how the label should interact with user input if it displays text.

  If the flags contain either `Qt::LinksAccessibleByKeyboard` or `Qt::TextSelectableByKeyboard` then the focus policy is also automatically set to `Qt::ClickFocus` .

  The default value depends on whether the `QPlainTextEdit` is read-only or editable, and whether it is a `QTextBrowser` or not.

### setTextInteractionFlags

    public final void setTextInteractionFlags(Qt.TextInteractionFlags flags)

  Specifies how the label should interact with user input if it displays text.

  If the flags contain either `Qt::LinksAccessibleByKeyboard` or `Qt::TextSelectableByKeyboard` then the focus policy is also automatically set to `Qt::ClickFocus` .

  The default value depends on whether the `QPlainTextEdit` is read-only or editable, and whether it is a `QTextBrowser` or not.

### setUndoRedoEnabled

    public final void setUndoRedoEnabled(boolean enable)

  This property holds whether undo and redo are enabled. Users are only able to undo or redo actions if this property is true, and if there is an action that can be undone (or redone).

  By default, this property is true.

### setWordWrapMode

    public final void setWordWrapMode(QTextOption.WrapMode policy)

  This property holds the mode `QPlainTextEdit` will use when wrapping text by words. By default, this property is set to `QTextOption::WrapAtWordBoundaryOrAnywhere` .

See also:
  `QTextOption::WrapMode` .

### tabChangesFocus

    public final boolean tabChangesFocus()

  This property holds whether Tab changes focus or is accepted as input. In some occasions text edits should not allow the user to input tabulators or change indentation using the Tab key, as this breaks the focus chain. The default is false.

### tabStopWidth

    public final int tabStopWidth()

  This property holds the tab stop width in pixels. By default, this property contains a value of 80.

### textCursor

    public final QTextCursor textCursor()

  Returns a copy of the `QTextCursor` that represents the currently visible cursor. Note that changes on the returned cursor do not affect `QPlainTextEdit`'s cursor; use `setTextCursor()` to update the visible cursor.

See also:
  `setTextCursor()`.

### textInteractionFlags

    public final Qt.TextInteractionFlags textInteractionFlags()

  Specifies how the label should interact with user input if it displays text.

  If the flags contain either `Qt::LinksAccessibleByKeyboard` or `Qt::TextSelectableByKeyboard` then the focus policy is also automatically set to `Qt::ClickFocus` .

  The default value depends on whether the `QPlainTextEdit` is read-only or editable, and whether it is a `QTextBrowser` or not.

### toPlainText

    public final java.lang.String toPlainText()

  This property gets and sets the plain text editor's contents. The previous contents are removed and undo/redo history is reset when this property is set.

  By default, for an editor with no contents, this property contains an empty string.

### undo

    public final void undo()

  Undoes the last operation.

  If there is no operation to undo, i.e. there is no undo step in the undo/redo history, nothing happens.

See also:
  `redo()`.

### wordWrapMode

    public final QTextOption.WrapMode wordWrapMode()

  This property holds the mode `QPlainTextEdit` will use when wrapping text by words. By default, this property is set to `QTextOption::WrapAtWordBoundaryOrAnywhere` .

See also:
  `QTextOption::WrapMode` .

### canInsertFromMimeData

    protected boolean canInsertFromMimeData(QMimeData source)

  This function returns true if the contents of the MIME data object, specified by `source`, can be decoded and inserted into the document. It is called for example when during a drag operation the mouse enters this widget and it is necessary to determine whether it is possible to accept the drag.

### createMimeDataFromSelection

    protected QMimeData createMimeDataFromSelection()

  This function returns a new MIME data object to represent the contents of the text edit's current selection. It is called when the selection needs to be encapsulated into a new `QMimeData` object; for example, when a drag and drop operation is started, or when data is copied to the clipboard.

  If you reimplement this function, note that the ownership of the returned `QMimeData` object is passed to the caller. The selection can be retrieved by using the `textCursor()` function.

### insertFromMimeData

    protected void insertFromMimeData(QMimeData source)

  This function inserts the contents of the MIME data object, specified by `source`, into the text edit at the current cursor position. It is called whenever text is inserted as the result of a clipboard paste operation, or when the text edit accepts data from a drag and drop operation.

### loadResource

    public java.lang.Object loadResource(int type,
                                         QUrl name)

  Loads the resource specified by the given `type` and `name`.

  This function is an extension of `QTextDocument::loadResource()`.

See also:
  `QTextDocument::loadResource()`.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD